Subject: bug#39380: 26.3: Opening files in vc-dir-mode with differing root and working dir fails

From: Dmitry Gutov <[email-masked]>
Date: Fri, 7 Feb 2020 14:03:21 +0300

On 07.02.2020 12:53, Eli Zaretskii wrote:
> I'll have to ask you to walk me through the change and explain how it
> solves the original issue.

There are two changes:

1. Having the returned file names relative to the working dir instead of 
the repository root. For that, we change 'hg status' to 'hg status re:'.

2. Only including the files inside the working dir in the output. That 
happens by adding '-I .' to the arguments. Otherwise, Mercurial adds, in 
the presented scenario, an entry like '../sub2/x', which is extraneous.

> the Mercurial documentation I've read seems
> to contradict what you are doing (e.g., it says "re:" should be
> immediately followed by a regexp).

You can search the manual for "hg status re:".

I agree it's a bit unclear (it also mentions "hg help patterns" for some 
reason), but here's an SO answer that got me this far: 
https://stackoverflow.com/a/46743585/615245